<cfcomponent>

	<cffunction name="init" access="public" output="false" returntype="service">
		<cfargument name="dao" type="dao" />
		<cfif structKeyExists(arguments, "dao")>
			<cfset setDao(arguments.dao) />
		</cfif>
		<cfreturn this />
	</cffunction>

	<cffunction name="setDao" access="public" output="false" returntype="void">
		<cfargument name="dao" type="dao" required="true" />
		<cfset variables.dao = dao />
	</cffunction>

	<cffunction name="someMethod" access="public" output="false" returntype="string">
		<cfset var result = "someMethod called" />
		<cftrace text="#result#" />
		<cfset variables.dao.makePersistent("no-op") />
		<cfset nonTransactionalMethod() />
		<cfreturn result />
	</cffunction>

	<cffunction name="nonTransactionalMethod" access="public" output="false" returntype="string">
		<cfset var result = "nonTransactionalMethod called" />
		<cftrace text="#result#" />
		<cfreturn result />
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>