<style type="text/css">
	.advice {
		border: 2px dashed #00c;
		background-color: #eef;
	}
	.methodinvocation {
		border: 2px dashed #0c0;
		background-color: #efe;
	}
	.proxy {
		border: 2px dashed #c00;
		background-color: #fee;
	}
	.proxyfactory {
		border: 2px dashed #c90;
		background-color: #fed;
	}
	.target {
		border: 2px dashed #cc0;
		background-color: #ffe;
	}
</style>

<h1>Initialization</h1>
<cfset proxyFactory = createObject("component", "proxyFactory").init() />
<cfset target = createObject("component", "target").init() />
<cfset proxy = proxyFactory.makeProxy(target) />
<cfset dependenttarget = createObject("component", "dependenttarget").init(proxy) />
<cfset dependentproxy = proxyFactory.makeProxy(dependenttarget) />

<h1>Direct Invocations</h1>
<cfset target.doSomething() />
<cfset target.doSomethingElse() />
<cfset dependenttarget.doSomething() />

<h1>Proxied Invocations</h1>
<cfset proxy.doSomething() />
<cfset proxy.doSomethingElse() />
<cfset dependentproxy.doSomething() />