<cfcomponent extends="target">

	<cffunction name="init" access="public" output="true" returntype="target">
		<cfargument name="target" required="true" />
		<fieldset class="proxy"><legend>proxy.init</legend>
		<cfset variables.my.target = target />
		<cfset variables.my.adviceChain = arrayNew(1) />
		<cfset arrayAppend(variables.my.adviceChain, createObject("component", "advice").init()) />
		<cfset arrayAppend(variables.my.adviceChain, createObject("component", "advice").init()) />
		</fieldset>
		<cfreturn this />
	</cffunction>

	<cffunction name="callMethod" access="private" output="true" returntype="void">
		<cfargument name="methodName" required="true" />
		<cfset var mi = "" />
		<fieldset class="proxy"><legend>proxy.callMethod</legend>
		<cfset mi = createObject("component", "methodinvocation").init(variables.my.target, methodName) />
		<cfset mi.setAdviceChain(variables.my.adviceChain) />
		<cfset mi.proceed() />
		</fieldset>
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>