<cfcomponent>

	<cffunction name="init" access="public" output="true" returntype="proxyfactory">
		<fieldset class="proxyfactory"><legend>proxyFactory.init</legend>
		</fieldset>
		<cfreturn this />
	</cffunction>

	<cffunction name="makeProxy" access="public" output="true" returntype="any">
		<cfargument name="target" required="true" />
		<cfset var proxy = "" />
		<cfset var nameRoot = "func_#replace(createUUID(), '-', '', 'all')#" />
		<cfset var temp = "" />
		<fieldset class="proxyfactory"><legend>proxyFactory.makeProxy</legend>
		<cfset proxy = createObject("component", "proxy").init(target) />
		<cffile action="read" file="#expandPath('_methodproxies.cfm')#" variable="temp" />
		<cfset temp = replace(temp, "##nameRoot##", nameRoot, "all") />
		<cffile action="write" file="#expandPath('#nameRoot#.cfm')#" output="#temp#" />
		<cfinclude template="#nameRoot#.cfm" />
		<cffile action="delete" file="#expandPath('#nameRoot#.cfm')#" />
		<cfset proxy.doSomething = variables[nameRoot & "_doSomething"] />
		<cfset proxy.doSomethingElse = variables[nameRoot & "_doSomethingElse"] />
		</fieldset>
		<cfreturn proxy />
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>