<cfapplication name="cs_preso_2006_11_16.aop" />
<cfinclude template="act_setup.cfm" />

<!--- locking --->
<cfif NOT structKeyExists(application, "appVarsLoaded") OR structKeyExists(attributes, "reload")>
<cfscript>
	csprops = structNew();
	csprops.dsn = "something";

	application.factory = createObject("component", "coldspring.beans.DefaultXmlBeanFactory").init(structNew(), csprops);
	application.factory.loadBeansFromXmlFile(expandPath("aop.xml"), true);

	application.appVarsLoaded = true;
	application.loadedAt = now();
</cfscript>
</cfif>
<!--- end locking --->
<cfset request.factory = application.factory />

<cfset service = request.factory.getBean("service") />
<cfset service.someMethod() />
<cfset service.nonTransactionalMethod() />

<cfset stack = request.factory.getBean('traceAdvice').getRequestData() />
<cfoutput>
<table border="1">
<tr>
	<th colspan="3">Method Invocations</th>
</tr>
<cfloop query="stack">
	<tr>
		<td style="padding-left:#(depth - 1) * 20#px">#listLast(target, ".")#.#method#</td>
		<td align="right">#duration# ms</td>
		<td align="right">#directDuration# ms</td>
	</tr>
</cfloop>
</table>
</cfoutput>
<cfdump var="#stack#" />