<cfcomponent>

	<cffunction name="init" access="public" output="true" returntype="methodinvocation">
		<cfargument name="target" required="true" />
		<cfargument name="methodName" required="true" />
		<fieldset class="methodinvocation"><legend>methodinvocation.init</legend>
		<cfset variables.my.target = target />
		<cfset variables.my.methodName = methodName />
		<cfset variables.my.adviceChain = arrayNew(1) />
		<cfset variables.my.adviceIndex = 0 />
		</fieldset>
		<cfreturn this />
	</cffunction>

	<cffunction name="setAdviceChain" access="public" output="true">
		<cfargument name="adviceChain" required="true" />
		<fieldset class="methodinvocation"><legend>methodinvocation.setAdviceChain</legend>
		<cfset variables.my.adviceChain = adviceChain />
		</fieldset>
	</cffunction>

	<cffunction name="proceed" access="public" output="true">
		<fieldset class="methodinvocation"><legend>methodinvocation.proceed</legend>
		<cfset my.adviceIndex = my.adviceIndex + 1 />
		<cfif my.adviceIndex LTE arrayLen(my.adviceChain)>
			<cfset my.adviceChain[my.adviceIndex].invokeMethod(this) />
		<cfelse>
			<cfinvoke component="#my.target#"
				method="#my.methodName#" />
		</cfif>
		</fieldset>
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>