<style type="text/css">
	.advice {
		border: 2px dashed #00c;
		background-color: #eef;
	}
	.methodinvocation {
		border: 2px dashed #0c0;
		background-color: #efe;
	}
	.proxy {
		border: 2px dashed #c00;
		background-color: #fee;
	}
	.proxyfactory {
		border: 2px dashed #c90;
		background-color: #fed;
	}
	.target {
		border: 2px dashed #cc0;
		background-color: #ffe;
	}
</style>
<h1>Initialization</h1>
<cfapplication name="test.withcs" sessionmanagement="false" clientmanagement="false" />
<cfparam name="url.rl" type="boolean" default="false" />
<cfif not structKeyExists( application, 'appInitialized' ) or url.rl>
<cflock name="appInitBlock" type="exclusive" timeout="10">
<cfif not structKeyExists( application, 'appInitialized' ) or url.rl>
	<cfset application.factory = createObject( 'component', 'coldspring.beans.DefaultXmlBeanFactory').init() />
	<cfset application.factory.loadBeansFromXmlFile(expandPath("context.xml")) />
	<cfset application.appInitialized = true />
</cfif>
</cflock>
</cfif>

<cfset target = application.factory.getBean("target_target") />
<cfset dependenttarget = application.factory.getBean("dependenttarget_target") />
<cfset proxy = application.factory.getBean("target") />
<cfset dependentproxy = application.factory.getBean("dependenttarget") />

<h1>Direct Invocations</h1>
<cfset target.doSomething() />
<cfset target.doSomethingElse() />
<cfset dependenttarget.doSomething() />

<h1>Proxied Invocations</h1>
<cfset proxy.doSomething() />
<cfset proxy.doSomethingElse() />
<cfset dependentproxy.doSomething() />